var Docker = require('dockerode');
var fs = require('fs');

module.exports = (api, options) => { 
    api.registerCommand('dockerize:build', args => {

        if(!fs.existsSync("./Dockerfile")) {
            console.log("## Error ## --> Docker file has not been generated, please use 'vue invoke dockerize' to generate your custom DockerFile.");
            return;
        }   

        var filesName = [];

        fs.readdirSync(process.cwd()).forEach(file => {
            filesName.push(file);
        });

        var docker = new Docker();

        docker.buildImage({
            context: process.cwd(),
            src: ['Dockerfile', ...filesName]
          }, {
            t: options.pluginOptions.dockerize.imageName
          }, function(error, output) {
            if (error) {
              return console.error(error);
            }
            output.pipe(process.stdout);
          });
      });

      api.registerCommand('dockerize:run', args => {
        docker.run(options.pluginOptions.dockerize.imageName, null, process.stdout,{
            "name": options.pluginOptions.dockerize.imageName + "_dockerized",
            "HostConfig": {
              "PortBindings": {
                "8080/tcp": [
                  {
                    "HostPort": "8080"
                  }
                ]
              }
            }
          }, function (err, data, container) {
            console.log(err);
            console.log(data);
          });
      });
}